#pragma once


#include <cigui/config.h>

#include <stdint.h>
#include <cigui/utils/MemoryDebug.hpp>

#include <cigui/core/App.hpp>

#ifdef _DEBUG
#define MEM_CHECKED_MAIN(rtc) \
	int rtc = 0; \
	MEMORY_INFO_DUMP(); \
	for (bool exit_main_mem_check_dump_tmp_var = true; exit_main_mem_check_dump_tmp_var == true; MEMORY_INFO_DUMP(), exit_main_mem_check_dump_tmp_var = false)
#else
#define MEM_CHECKED_MAIN(rtc) int rtc = 0;
#endif


namespace cig {
constexpr unsigned int VERSION_MAJOR = CIGUI_VERSION_MAJOR;
constexpr unsigned int VERSION_MINOR = CIGUI_VERSION_MINOR;
constexpr unsigned int VERSION_PATCH = CIGUI_VERSION_PATCH;

// Version string
constexpr const char *VERSION = CIGUI_VERSION;
}