﻿#pragma once

namespace cig::Memory
{
	template<typename T>
	T* alloc(size_t count = 1);

	template<typename T>
	T* realloc(T* data, size_t from, size_t to);

	template<typename T>
	void dealloc(T* data);

	template<typename T>
	T* dupalloc(const T* data, size_t count = 1);
}

#include <cigui/core/Memory.inl>